// Драйвер для PCI платы

#define DRIVER_VERSION 1

// Максимально возможное количество плат (фактически количество миноров)
#define MAX_BOARDS_COUNT (1 << MINORBITS)

#define SUCCESS 0

u32 Board_memory_begin = 0x10000000;

// Структура расширения устройства
struct nmx_device_extension
{
	unsigned int Num; // Номер платы
	char Name[10]; // Название платы (mcXXXX_XX)

	atomic_t Open_count; // Количество открытий файла устройства

	struct pci_dev *dev; // Указатель на основную структуру устройства
	struct cdev cdev; // Внутрення структура ядра, представляющая символьное устройство
	unsigned int irq; // Номер прерывания
	struct semaphore sem; // Мьютекс

	unsigned long PCICRegs_u; // Адрес (не мапированный) управляющих регистров (RUK)
	unsigned long ShMem_u; // Адрес (не мапированный) разделяемой памяти
	unsigned long PCICRegs_m; // Адрес (мапированный) управляющих регистров (RUK)
	unsigned long ShMem_m; // Адрес (мапированный) разделяемой памяти
	unsigned long PCICRegs_size; // Размер управляющих регистров (RUK)
	unsigned long ShMem_size; // Размер разделяемой памяти

	wait_queue_head_t queue; // Голова очереди ожидания
	int int_dma; // Флаг прерывания по завершению DMA

	struct tasklet_struct Interrupt_tasklet; // Тасклет прерывания PCI
	struct list_head Wait_interrupt_list; // Голова списка ожидания прерывания
	spinlock_t Wait_interrupt_lock; // Спин-блокировка доступа к списку ожидания прерывания
};

// Элемент аппаратного списка разборки
struct hw_scatterlist
{
	u32 PCI_address;
	u32 Board_address;
	u32 Size;
	u32 Next;
};

// Структура ожидания прерывания
struct Wait_interrupt
{
	struct list_head list; // Структура связанного списка
	u32 Proc_mask; // Маска процессора
	int tgid; // Идентификатор группы потоков
	int int_pci; // Условие пробуждения
};
